//****************************************************************************
// Unit Name: Vcl.Dialogs
//****************************************************************************
// This file is auto generated with paxCompiler engine.                       
// Import mode: local import, global members only.
// ---------------------------------------------------------------------------
// Site: http://www.paxcompiler.com                                           
// Author: Alexander Baranovsky (paxscript@gmail.com)                         
// ---------------------------------------------------------------------------
// Copyright (c) Alexander Baranovsky, 2014.                                  
// ---------------------------------------------------------------------------
// Portion copyright Full Circle Development Ltd.                             
// Content: initial design of importer.                                       
// ---------------------------------------------------------------------------
// Code Version: 1.0                                                    
//****************************************************************************

unit IMP_Vcl.Dialogs;
interface
uses
  PaxCompiler;


function Register_Vcl_Dialogs(compiler: TPaxCompiler): Integer;


implementation


uses
  PAXCOMP_STDLIB,
  PaxRegister,
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  Winapi.CommDlg,
  Vcl.Printers,
  System.Classes,
  Vcl.Graphics,
  Vcl.Controls,
  Vcl.Forms,
  Vcl.StdCtrls,
  Winapi.ShlObj,
  Winapi.CommCtrl,
  Vcl.ComCtrls,
  System.UITypes,
  Vcl.Dialogs;


function RegisterConstant__MaxCustomColors(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxCustomColors') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MaxCustomColors', 16);
end;


function RegisterConstant__tdiNone(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('tdiNone') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'tdiNone', 0);
end;


function RegisterConstant__tdiWarning(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('tdiWarning') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'tdiWarning', 1);
end;


function RegisterConstant__tdiError(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('tdiError') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'tdiError', 2);
end;


function RegisterConstant__tdiInformation(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('tdiInformation') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'tdiInformation', 3);
end;


function RegisterConstant__tdiShield(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('tdiShield') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'tdiShield', 4);
end;


function Address_CreateMessageDialog_1: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons): TForm;
var
  P: T;
begin
  P := CreateMessageDialog;
  Move(P, result, SizeOf(Pointer));
end;


// function CreateMessageDialog(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons): TForm; overload;
function RegisterFunction_CreateMessageDialog_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CreateMessageDialog') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CreateMessageDialog'
    , 'TForm' // result type
    , Address_CreateMessageDialog_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
end;


function Address_CreateMessageDialog_2: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; DefaultButton: TMsgDlgBtn): TForm;
var
  P: T;
begin
  P := CreateMessageDialog;
  Move(P, result, SizeOf(Pointer));
end;


// function CreateMessageDialog(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; DefaultButton: TMsgDlgBtn): TForm; overload;
function RegisterFunction_CreateMessageDialog_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CreateMessageDialog') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CreateMessageDialog'
    , 'TForm' // result type
    , Address_CreateMessageDialog_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'DefaultButton', 'TMsgDlgBtn', _parVAL);
end;


function Address_MessageDlg_1: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer;
var
  P: T;
begin
  P := MessageDlg;
  Move(P, result, SizeOf(Pointer));
end;


// function MessageDlg(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer; overload; inline;
function RegisterFunction_MessageDlg_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MessageDlg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MessageDlg'
    , _typeINTEGER // result type
    , Address_MessageDlg_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
end;


function Address_MessageDlg_2: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; DefaultButton: TMsgDlgBtn): Integer;
var
  P: T;
begin
  P := MessageDlg;
  Move(P, result, SizeOf(Pointer));
end;


// function MessageDlg(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; DefaultButton: TMsgDlgBtn): Integer; overload; inline;
function RegisterFunction_MessageDlg_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MessageDlg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MessageDlg'
    , _typeINTEGER // result type
    , Address_MessageDlg_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'DefaultButton', 'TMsgDlgBtn', _parVAL);
end;


function Address_MessageDlgPos_1: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer): Integer;
var
  P: T;
begin
  P := MessageDlgPos;
  Move(P, result, SizeOf(Pointer));
end;


// function MessageDlgPos(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer): Integer; overload; inline;
function RegisterFunction_MessageDlgPos_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MessageDlgPos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MessageDlgPos'
    , _typeINTEGER // result type
    , Address_MessageDlgPos_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
end;


function Address_MessageDlgPos_2: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;
  DefaultButton: TMsgDlgBtn): Integer;
var
  P: T;
begin
  P := MessageDlgPos;
  Move(P, result, SizeOf(Pointer));
end;


// function MessageDlgPos(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;  DefaultButton: TMsgDlgBtn): Integer; overload; inline;
function RegisterFunction_MessageDlgPos_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MessageDlgPos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MessageDlgPos'
    , _typeINTEGER // result type
    , Address_MessageDlgPos_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'DefaultButton', 'TMsgDlgBtn', _parVAL);
end;


function Address_MessageDlgPosHelp_1: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;
  const HelpFileName: string): Integer;
var
  P: T;
begin
  P := MessageDlgPosHelp;
  Move(P, result, SizeOf(Pointer));
end;


// function MessageDlgPosHelp(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;  const HelpFileName: string): Integer; overload;
function RegisterFunction_MessageDlgPosHelp_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MessageDlgPosHelp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MessageDlgPosHelp'
    , _typeINTEGER // result type
    , Address_MessageDlgPosHelp_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'HelpFileName', _typeUNICSTRING, _parCONST);
end;


function Address_MessageDlgPosHelp_2: Pointer;
type
  T = function (const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;
  const HelpFileName: string; DefaultButton: TMsgDlgBtn): Integer;
var
  P: T;
begin
  P := MessageDlgPosHelp;
  Move(P, result, SizeOf(Pointer));
end;


// function MessageDlgPosHelp(const Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;  const HelpFileName: string; DefaultButton: TMsgDlgBtn): Integer; overload;
function RegisterFunction_MessageDlgPosHelp_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MessageDlgPosHelp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MessageDlgPosHelp'
    , _typeINTEGER // result type
    , Address_MessageDlgPosHelp_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'HelpFileName', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DefaultButton', 'TMsgDlgBtn', _parVAL);
end;


function Address_TaskMessageDlg_1: Pointer;
type
  T = function (const Title, Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer;
var
  P: T;
begin
  P := TaskMessageDlg;
  Move(P, result, SizeOf(Pointer));
end;


// function TaskMessageDlg(const Title, Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer; overload; inline;
function RegisterFunction_TaskMessageDlg_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TaskMessageDlg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TaskMessageDlg'
    , _typeINTEGER // result type
    , Address_TaskMessageDlg_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Title', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
end;


function Address_TaskMessageDlg_2: Pointer;
type
  T = function (const Title, Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; DefaultButton: TMsgDlgBtn): Integer;
var
  P: T;
begin
  P := TaskMessageDlg;
  Move(P, result, SizeOf(Pointer));
end;


// function TaskMessageDlg(const Title, Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; DefaultButton: TMsgDlgBtn): Integer; overload; inline;
function RegisterFunction_TaskMessageDlg_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TaskMessageDlg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TaskMessageDlg'
    , _typeINTEGER // result type
    , Address_TaskMessageDlg_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Title', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'DefaultButton', 'TMsgDlgBtn', _parVAL);
end;


function Address_TaskMessageDlgPos_1: Pointer;
type
  T = function (const Title, Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer): Integer;
var
  P: T;
begin
  P := TaskMessageDlgPos;
  Move(P, result, SizeOf(Pointer));
end;


// function TaskMessageDlgPos(const Title, Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer): Integer; overload; inline;
function RegisterFunction_TaskMessageDlgPos_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TaskMessageDlgPos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TaskMessageDlgPos'
    , _typeINTEGER // result type
    , Address_TaskMessageDlgPos_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Title', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
end;


function Address_TaskMessageDlgPos_2: Pointer;
type
  T = function (const Title, Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;
  DefaultButton: TMsgDlgBtn): Integer;
var
  P: T;
begin
  P := TaskMessageDlgPos;
  Move(P, result, SizeOf(Pointer));
end;


// function TaskMessageDlgPos(const Title, Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;  DefaultButton: TMsgDlgBtn): Integer; overload; inline;
function RegisterFunction_TaskMessageDlgPos_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TaskMessageDlgPos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TaskMessageDlgPos'
    , _typeINTEGER // result type
    , Address_TaskMessageDlgPos_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Title', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'DefaultButton', 'TMsgDlgBtn', _parVAL);
end;


function Address_TaskMessageDlgPosHelp_1: Pointer;
type
  T = function (const Title, Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;
  const HelpFileName: string): Integer;
var
  P: T;
begin
  P := TaskMessageDlgPosHelp;
  Move(P, result, SizeOf(Pointer));
end;


// function TaskMessageDlgPosHelp(const Title, Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;  const HelpFileName: string): Integer; overload;
function RegisterFunction_TaskMessageDlgPosHelp_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TaskMessageDlgPosHelp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TaskMessageDlgPosHelp'
    , _typeINTEGER // result type
    , Address_TaskMessageDlgPosHelp_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Title', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'HelpFileName', _typeUNICSTRING, _parCONST);
end;


function Address_TaskMessageDlgPosHelp_2: Pointer;
type
  T = function (const Title, Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;
  const HelpFileName: string; DefaultButton: TMsgDlgBtn): Integer;
var
  P: T;
begin
  P := TaskMessageDlgPosHelp;
  Move(P, result, SizeOf(Pointer));
end;


// function TaskMessageDlgPosHelp(const Title, Msg: string; DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer;  const HelpFileName: string; DefaultButton: TMsgDlgBtn): Integer; overload;
function RegisterFunction_TaskMessageDlgPosHelp_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TaskMessageDlgPosHelp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TaskMessageDlgPosHelp'
    , _typeINTEGER // result type
    , Address_TaskMessageDlgPosHelp_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Title', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DlgType', 'TMsgDlgType', _parVAL);
  compiler.RegisterParameter(result, 'Buttons', 'TMsgDlgButtons', _parVAL);
  compiler.RegisterParameter(result, 'HelpCtx', 'Longint', _parVAL);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'HelpFileName', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'DefaultButton', 'TMsgDlgBtn', _parVAL);
end;


// procedure ShowMessage(const Msg: string);
function RegisterProcedure_ShowMessage(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ShowMessage') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ShowMessage'
    , _typeVOID // result type
    , @ ShowMessage // address
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
end;


// procedure ShowMessageFmt(const Msg: string; Params: array of const);
function RegisterProcedure_ShowMessageFmt(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ShowMessageFmt') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ShowMessageFmt'
    , _typeVOID // result type
    , @ ShowMessageFmt // address
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Params', H_DYNARRAY_TVarRec, _parVAL);
end;


// procedure ShowMessagePos(const Msg: string; X, Y: Integer);
function RegisterProcedure_ShowMessagePos(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ShowMessagePos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ShowMessagePos'
    , _typeVOID // result type
    , @ ShowMessagePos // address
    );
  compiler.RegisterParameter(result, 'Msg', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'X', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Y', _typeINTEGER, _parVAL);
end;


// function (const Values: array of string): Boolean;
function RegisterMethodFunction_TInputCloseQueryFunc___ANONYM_MTD_(H: Integer; compiler: TPaxCompiler): Integer;
begin
  result := compiler.RegisterMethod(H, '__ANONYM_MTD_'
    , _typeBOOLEAN // result type
    , nil // address
    , _ccREGISTER // call convention
    , false // class method
    , _cmNONE
    , - 2
    );
  compiler.RegisterParameter(result, 'Values', H_DYNARRAY_UnicodeString, _parCONST);
end;


// function InputBox(const ACaption, APrompt, ADefault: string): string;
function RegisterFunction_InputBox(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InputBox') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InputBox'
    , _typeUNICSTRING // result type
    , @ InputBox // address
    );
  compiler.RegisterParameter(result, 'ACaption', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'APrompt', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'ADefault', _typeUNICSTRING, _parCONST);
end;


function Address_InputQuery_1: Pointer;
type
  T = function (const ACaption: string; const APrompts: array of string; var AValues: array of string; CloseQueryFunc: TInputCloseQueryFunc = nil): Boolean;
var
  P: T;
begin
  P := InputQuery;
  Move(P, result, SizeOf(Pointer));
end;


// function InputQuery(const ACaption: string; const APrompts: array of string; var AValues: array of string; CloseQueryFunc: TInputCloseQueryFunc = nil): Boolean; overload;
function RegisterFunction_InputQuery_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InputQuery') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InputQuery'
    , _typeBOOLEAN // result type
    , Address_InputQuery_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'ACaption', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'APrompts', H_DYNARRAY_UnicodeString, _parCONST);
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_UnicodeString, _parVAR);
  compiler.RegisterParameter(result, 'CloseQueryFunc', 'TInputCloseQueryFunc', _parVAL, true, 'nil');
end;


function Address_InputQuery_2: Pointer;
type
  T = function (const ACaption: string; const APrompts: array of string; var AValues: array of string; CloseQueryEvent: TInputCloseQueryEvent; Context: TObject = nil): Boolean;
var
  P: T;
begin
  P := InputQuery;
  Move(P, result, SizeOf(Pointer));
end;


// function InputQuery(const ACaption: string; const APrompts: array of string; var AValues: array of string; CloseQueryEvent: TInputCloseQueryEvent; Context: TObject = nil): Boolean; overload;
function RegisterFunction_InputQuery_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InputQuery') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InputQuery'
    , _typeBOOLEAN // result type
    , Address_InputQuery_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'ACaption', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'APrompts', H_DYNARRAY_UnicodeString, _parCONST);
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_UnicodeString, _parVAR);
  compiler.RegisterParameter(result, 'CloseQueryEvent', 'TInputCloseQueryEvent', _parVAL);
  compiler.RegisterParameter(result, 'Context', 'TObject', _parVAL, true, 'nil');
end;


function Address_InputQuery_3: Pointer;
type
  T = function (const ACaption, APrompt: string; var Value: string): Boolean;
var
  P: T;
begin
  P := InputQuery;
  Move(P, result, SizeOf(Pointer));
end;


// function InputQuery(const ACaption, APrompt: string; var Value: string): Boolean; overload;
function RegisterFunction_InputQuery_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InputQuery') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InputQuery'
    , _typeBOOLEAN // result type
    , Address_InputQuery_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'ACaption', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'APrompt', _typeUNICSTRING, _parCONST);
  compiler.RegisterParameter(result, 'Value', _typeUNICSTRING, _parVAR);
end;


// function PromptForFileName(var AFileName: string; const AFilter: string = '';  const ADefaultExt: string = ''; const ATitle: string = '';  const AInitialDir: string = ''; SaveDialog: Boolean = False): Boolean;
function RegisterFunction_PromptForFileName(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PromptForFileName') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PromptForFileName'
    , _typeBOOLEAN // result type
    , @ PromptForFileName // address
    );
  compiler.RegisterParameter(result, 'AFileName', _typeUNICSTRING, _parVAR);
  compiler.RegisterParameter(result, 'AFilter', _typeUNICSTRING, _parCONST, true, '');
  compiler.RegisterParameter(result, 'ADefaultExt', _typeUNICSTRING, _parCONST, true, '');
  compiler.RegisterParameter(result, 'ATitle', _typeUNICSTRING, _parCONST, true, '');
  compiler.RegisterParameter(result, 'AInitialDir', _typeUNICSTRING, _parCONST, true, '');
  compiler.RegisterParameter(result, 'SaveDialog', _typeBOOLEAN, _parVAL, true, 'False');
end;


function RegisterVariable_ForceCurrentDirectory(H: Integer; compiler: TPaxCompiler): Integer;
var
  T: Integer;
begin
  if not Compiler.InScript('ForceCurrentDirectory') then begin result := 0; Exit; end;
  T := _typeBOOLEAN;
  result := compiler.RegisterVariable(H, 'ForceCurrentDirectory', T, @ForceCurrentDirectory);
end;


function RegisterVariable_UseLatestCommonDialogs(H: Integer; compiler: TPaxCompiler): Integer;
var
  T: Integer;
begin
  if not Compiler.InScript('UseLatestCommonDialogs') then begin result := 0; Exit; end;
  T := _typeBOOLEAN;
  result := compiler.RegisterVariable(H, 'UseLatestCommonDialogs', T, @UseLatestCommonDialogs);
end;


procedure Part1(result: Integer; compiler: TPaxCompiler);
begin
  RegisterConstant__MaxCustomColors(result, compiler);
  RegisterConstant__tdiNone(result, compiler);
  RegisterConstant__tdiWarning(result, compiler);
  RegisterConstant__tdiError(result, compiler);
  RegisterConstant__tdiInformation(result, compiler);
  RegisterConstant__tdiShield(result, compiler);
  RegisterFunction_CreateMessageDialog_1(result, compiler);
  RegisterFunction_CreateMessageDialog_2(result, compiler);
  RegisterFunction_MessageDlg_1(result, compiler);
  RegisterFunction_MessageDlg_2(result, compiler);
  RegisterFunction_MessageDlgPos_1(result, compiler);
  RegisterFunction_MessageDlgPos_2(result, compiler);
  RegisterFunction_MessageDlgPosHelp_1(result, compiler);
  RegisterFunction_MessageDlgPosHelp_2(result, compiler);
  RegisterFunction_TaskMessageDlg_1(result, compiler);
  RegisterFunction_TaskMessageDlg_2(result, compiler);
  RegisterFunction_TaskMessageDlgPos_1(result, compiler);
  RegisterFunction_TaskMessageDlgPos_2(result, compiler);
  RegisterFunction_TaskMessageDlgPosHelp_1(result, compiler);
  RegisterFunction_TaskMessageDlgPosHelp_2(result, compiler);
  RegisterProcedure_ShowMessage(result, compiler);
  RegisterProcedure_ShowMessageFmt(result, compiler);
  RegisterProcedure_ShowMessagePos(result, compiler);
  RegisterFunction_InputBox(result, compiler);
  RegisterFunction_InputQuery_1(result, compiler);
  RegisterFunction_InputQuery_2(result, compiler);
  RegisterFunction_InputQuery_3(result, compiler);
  RegisterFunction_PromptForFileName(result, compiler);
  RegisterVariable_ForceCurrentDirectory(result, compiler);
  RegisterVariable_UseLatestCommonDialogs(result, compiler);
end;

function Register_Vcl_Dialogs(compiler: TPaxCompiler): Integer;
begin
  if not compiler.InScript('Vcl.Dialogs') then begin result := 0; Exit; end;
  result := compiler.RegisterNamespace(0, 'Vcl.Dialogs');
  compiler.RegisterUsingNamespace('Winapi.Windows');
  compiler.RegisterUsingNamespace('Winapi.Messages');
  compiler.RegisterUsingNamespace('System.SysUtils');
  compiler.RegisterUsingNamespace('Winapi.CommDlg');
  compiler.RegisterUsingNamespace('Vcl.Printers');
  compiler.RegisterUsingNamespace('System.Classes');
  compiler.RegisterUsingNamespace('Vcl.Graphics');
  compiler.RegisterUsingNamespace('Vcl.Controls');
  compiler.RegisterUsingNamespace('Vcl.Forms');
  compiler.RegisterUsingNamespace('Vcl.StdCtrls');
  compiler.RegisterUsingNamespace('Winapi.ShlObj');
  compiler.RegisterUsingNamespace('Winapi.CommCtrl');
  compiler.RegisterUsingNamespace('Vcl.ComCtrls');
  compiler.RegisterUsingNamespace('System.UITypes');
  Part1(result, compiler);
  compiler.UnregisterUsingNamespaces;
end;

end.
